/**
 *   Programeksempel nr 17 - Strre programeksempel.
 *
 *   som vektlegger:
 *     - lkker (for, while, do)
 *     - operatorer (relasjon, logiske, artimetiske)
 *     - utskrift/innlesning
 *     - array-bruk
 *     - casting
 *
 *   Programmet:
 *     - leser antall dager i aktuell mned
 *     - leser inn min.temp, max.temp og nedbr for hver dag i mneden
 *     - oppummerer og regner gjennomsnittet for disse verdiene
 *
 *   @file     EKS_17.C
 *   @author   Frode Haug, NTNU
 */


#include <stdio.h>           //  printf, scanf

const int MINTEMP   = -70;   ///<  Absolutt laveste mulige temperatur.
const int MAXTEMP   =  70;   ///<  Absolutt hyeste mulige temperatur.
const int MAXNEDBOR = 200;   ///<  Absolutt hyeste mulige nedbr pr.dgn.
const int MINDAGER  =   5;   ///<  Minimum antall dager i en mned.
const int MAXDAGER  =  31;   ///<  Maksimum antall dager i en mned.

/**
 *  Hovedprogrammet:
 */
int main ()  {
  char svar;                 //  Brukersvar til om vil fortsette eller ei.
  int  antDager,             //  Antall dager i aktuell mned.
       min,                  //  Min.temp EN gitt dag.
       max,                  //  Max.temp EN gitt dag.
       nedbor,               //  Nedbr EN gitt dag.
       totMin,               //  TOTALT min.grader i aktuell mned.
       totMax,               //  TOTALT max.grader i aktuell mned.
       totNedbor;            //  TOTALT nedbr i aktuell mned.
  int  alleMin[MAXDAGER],    //  ALLE min.temper i mneden.
       alleMax[MAXDAGER],    //  ALLE max.temper i mneden.
       alleNedbor[MAXDAGER]; //  ALL nedbr i mneden.

  printf("\nLese inn vrdata for en mned (J/n): ");   //  Kjre programmet?
  scanf(" %c", &svar);

  while (svar != 'N'  &&  svar != 'n') { //  S lenge nsker (IKKE svart 'N'):
     do {                    //  Leser antall dager i mneden (28-31):
        printf("Antall dager i mneden (%i-%i):  ", MINDAGER, MAXDAGER);
        scanf("%i", &antDager);
     } while (antDager < MINDAGER  ||  antDager > MAXDAGER);

     for (int i = 0;  i < antDager;  i++)  { //  Gr gjennom HELE mneden:
         printf("\nDag nr.%2i:\n", i+1);

         do {                             //  Leser korrekt min.temp dag nr.i:
           printf("\tMinimumstemp (%2i til %2i): ", MINTEMP, MAXTEMP);
           scanf("%i", &min);
         } while(min < MINTEMP ||  min > MAXTEMP);
         alleMin[i] = min;                //  Lagrer unna innlest verdi.

         do {                             //  Leser korrekt max.temp dag nr.i:
            printf("\tMaksimumstemp (%2i til %2i): ", min, MAXTEMP);
            scanf("%i", &max);
         } while(max < min  ||  max > MAXTEMP);
         alleMax[i] = max;                //  Lagrer unna innlest verdi.

         do {                             //  Leser korrekt nedbr dag nr.i:
            printf("\tNedbr (0 til %i): ", MAXNEDBOR);
            scanf("%i", &nedbor);
         } while(nedbor < 0  ||  nedbor > MAXNEDBOR);
         alleNedbor[i] = nedbor;          //  Lagrer unna innlest verdi.
     }

 	 totMin = totMax = totNedbor = 0;          //  Nullstiller totalsummer.
     for (int i = 0;  i < antDager;  i++)  { //  Gr gjennom HELE mneden:
         totMin    += alleMin[i];            //  Oppsummerer tot.min.
         totMax    += alleMax[i];            //  Oppsummerer tot.max.
         totNedbor += alleNedbor[i];         //  Oppsummerer tot.nedbr.
     }
                                    //  Skriver gjennomsnitter og EN totalsum:
     printf("\n\nGjennomsnittlig min.temp: %.2f grader C\n",
                                                      (float)totMin/antDager);
   printf("Gjennomsnittlig max.temp: %.2f grader C\n",(float)totMax/antDager);
     printf("Gjennomsnittlig nedbr:   %.2f mm\n", (float)totNedbor/antDager);
     printf("Total nedbr i mneden:   %i mm\n", totNedbor);
                                             //  Kjre programmet igjen?
     printf("\nLese inn vrdata for en mned til (J/n): ");
     scanf(" %c", &svar);
  }

  printf("\n\n\nHa en fortsatt god (vr(syk))dag!\n\n");

  return 0;
}
